from distutils.core import setup, Extension

setup (
	name = "PyIsect",
	version = "1.0",
	description = "Python interface to isect",
	author = "Thomas Gagne",
	author_email = "tgagne@ix.netcom.com",
	url = "http://home.netcom.com/~tgagne",
	py_modules = [ "CStructure", "IsdIO"],
	ext_modules = [
		Extension(
			"isdio", 
			["isdio.c"],
			libraries=["isdio", "isect"]
		)
	]
)
