;
;Isectd echo worker in Scheme
;
;(c-declare "#include \"isdio.h\"")......................................we shouldn't need this now
;
;
;Create all the accessor functions in C...Yes this is really C code not Scheme!
(c-declare #<<end-of-c-declare

#include "isdio.h"

isdHeader* make_isdHeader() {
  isdHeader* p = (isdHeader*) malloc(sizeof(isdHeader));
  return p;
}
void free_isdHeader( isdHeader* p ){free(p);}

int isdHeader_get_len(isdHeader* p) { return p->len;}
void isdHeader_set_len (isdHeader* p, int32_t x) { p->len = x;}

int isdHeader_get_reply(isdHeader* p) { return p->reply;}
void isdHeader_set_reply (isdHeader* p, int16_t x) { p->reply = x;}

int isdHeader_get_more(isdHeader* p) { return p->more;}
void isdHeader_set_more (isdHeader* p, int16_t x) { p->more = x;}

end-of-c-declare
)
;
;Scheme C declarations
;
(c-define-type Sstruct* (pointer "isdHeader"))
(define make-isdHeader (c-lambda () Sstruct* "make_isdHeader"))
(define free-isdHeader (c-lambda (Sstruct*) void "free_isdHeader"))
;(define make-isdHeader (c-lambda () isdHeader "___result_voidstar = ___EXT(___alloc_rc)(sizeof(isdHeader));"))....not needed

(define isdHeader_get_len (c-lambda (Sstruct*) int32 "isdHeader_get_len"))
(define isdHeader_set_len (c-lambda (Sstruct* int32) void "isdHeader_set_len"))

(define isdHeader_get_reply (c-lambda (Sstruct*) int16 "isdHeader_get_reply"))
(define isdHeader_set_reply (c-lambda (Sstruct* int16) void "isdHeader_set_reply"))

(define isdHeader_get_more (c-lambda (Sstruct*) int16 "isdHeader_get_more"))
(define isdHeader_set_more (c-lambda (Sstruct* int16) void "isdHeader_set_more"))

;Isectd functions
(define isdAttach (c-lambda (nonnull-char-string nonnull-char-string nonnull-char-string int) int "isdAttach"))
(define isdLogin (c-lambda (nonnull-char-string nonnull-char-string int) int "isdLogin"))
(define isdLogout (c-lambda (int) void "isdLogout"))
(define isdSend (c-lambda (int nonnull-char-string int (pointer "isdHeader")) int "isdSend"))
(define isdRecv (c-lambda (int (pointer "isdHeader")) nonnull-char-string "isdRecv"))
#|
;...Used for testing that we have attached to the library, but not in general use...
;(define isdLogInit (c-lambda (int nonnull-char-string-list) void "isdLogInit"))
;(isdLogInit (-(length (command-line))1) (command-line))
;
|#
;
;The Scheme program starts below.
;
(define socket 0)
(define my-line command-line)
(define isdHead* (make-isdHeader))

;The first three arguments of the command line are defined by Isectd.
;You can pass whatever you like to your worker as long as it is from
;argument 4 onwards.
(if (>= (-(length (my-line))1) 3)
	(begin 
		(set! socket (isdAttach (list-ref (my-line) 1) (list-ref (my-line) 2) (list-ref (my-line) 3) 0))
		(let loop()
			(isdSend socket (isdRecv socket isdHead*) (isdHeader_get_len isdHead*) isdHead*)	
		(if (> socket 0)(loop)))
		)		
	(begin
		(println "This is an Isectd worker.  It can only be started by Isectd."))
)
(isdLogout socket)
(free-isdHeader isdHead*); included for completeness, but not needed because program is ending anyway
