/* 
   W Robert Kellock 2003/01/28 
   Visual Basic cannot handle __declspec DLL's
   which the rest of Isectd has been built with.  It
   uses __stdcall exporting, hence this wrapper DLL.
*/

#ifndef _DLL_H_
#define _DLL_H_

#if BUILDING_DLL
#define Xport2 __declspec (dllexport) __stdcall
#else
#define Xport2 __declspec (dllimport) __stdcall
#endif

#include <isdio.h>

/* Used by VB workers */
Xport2 int vbAttach(const char *, const char *, char *);
/* Used by VB clients */
Xport2 int vbLogin(const char *, const char *, int);
/* Used by VB workers & VB clients */
Xport2 void vbLogout(int);
Xport2 int  vbSend(int, char *, isdHeader *);
char * Xport2 vbRecv(int, isdHeader *);

#endif /* _DLL_H_ */
