#include <mingw.h> /* W Robert Kellock 2002/12/18 soft path */
#include <stdio.h>
#include <signal.h>
#include <errno.h>

int 
rmtkill(buffer, size)
char *buffer;
int size;
{
	int err, argc;
	int pid, signal;
	char argv[3][32];

	err = -1;

	if ((argc = sscanf(buffer, "%s%s%s", argv[0], argv[1], argv[2])) >= 2) {
		signal = SIGTERM;
		if (argc == 3)			/* they passed a signal and a pid */
			signal = abs(atoi(argv[1]));
		pid = atoi(argv[argc - 1]);
#ifndef _Windows		        /* W Robert Kellock 2002/08/15 */
		err = kill(pid, signal);
#endif		
	}

	return err;
}

