#include "isectd.h"
#include <signal.h>
#ifdef _Windows
/* W Robert Kellock 2002/08/09 a hack so that this compiles.
This routine is not used in Windows anyway.  See init.c */
#define SIGALRM SIGABRT
#endif
void 
isdHandler(int sig)
{
	int i;
	switch (sig) {
	case SIGALRM:
		if (isdData.Buckets[0] > isdData.PeakBucket)
			isdData.PeakBucket = isdData.Buckets[0];
		for (i = isdData.NumBuckets; i > 0; i--)
			isdData.Buckets[i] = isdData.Buckets[i - 1];
		isdData.Buckets[0] = 0;
		/* alarm(isdData.BucketSecs); W Robert Kellock 2002/08/14 */
		break;
	default:
		isdLogEvent("SIGNAL %d", sig);
		break;
	}
	signal(sig, isdHandler);
}
