#ifndef TVFUNCS_H
#define TVFUNCS_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/* W Robert Kellock 2002/08/09 Changed from sys/time.h to include libisect.h */
#include "libisect.h"

#ifdef _Windows 
/* 
W Robert Kellock 2002/08/09 was PROTOTYPES
2002/08/16 removed extern operator
 */
Xport struct timeval tvMinus(struct timeval *, struct timeval *);
Xport struct timeval tvAverage(struct timeval, struct timeval, int);
#else
Xport struct timeval tvMinus();
Xport struct timeval tvAverage();
#endif

#endif
