# Filename : Isectd.pl
#
# This is the first time I've used PERL and I am amazed. It feels like Python without the formatting. It only took me 
# an hour and I had this working! It's by far the most concise program too. Python executes a little faster.
#

use IO::Socket;

# create the socket, connect to the port
$sock = new IO::Socket::INET (PeerAddr => 'localhost', PeerPort => '5501', Proto => 'tcp',);
die "Could not create socket: $!\n" unless $sock;

$isdBadge = pack('a7a3a5a3a30','','2','','','op');
$isdHeader = pack('a7a3a3a9a3a3a3a8a9','48','','','','','','','','');# must always contain the message length
$dataOut = "clients\0";

$line = $isdHeader . $isdBadge;
$isdHeader = pack('a7a3a3a9a3a3a3a8a9',length($dataOut),'1','','','','','','','');# must always contain the message length
$out = $line . $isdHeader . $dataOut;
#
# there should be some kind of peek statement between the recv and print statements below otherwise the print statement
# might execute before recv has had enough time to retrieve everything from the buffer
#
$sock->send($out);
$sock->recv($in, 48);
print "\n".$in;
$sock->recv($final, $in);# the read length of $in is implied because it is the first substring in isdHeader
print "\n".$final;
close($sock);
