#ifndef _DLL_H_
#define _DLL_H_

/* 
   W Robert Kellock 2002/08/30 
   Build DLL, use DLL or static library
*/
#if BUILDING_DLL
#define Xport __declspec (dllexport)
#elif STATIC_LIB
#define Xport _export far pascal
#else
#define Xport __declspec (dllimport)
#endif

#include <isdio.h>
#include <Python.h>

PyObject * Xport attach(PyObject *self, PyObject *args);
PyObject * Xport PyIsdSend(PyObject *self, PyObject *args);
PyObject * Xport recvHeader(PyObject *self, PyObject *args);
PyObject * Xport recvAll(PyObject *self, PyObject *args);
PyObject * Xport login(PyObject *self, PyObject *args);
PyObject * Xport logout(PyObject *self, PyObject *args);
void Xport initpyisdio(void);

#endif /* _DLL_H_ */
