#ifndef RMT_H
#define RMT_H

#include <mingw.h> /* W Robert Kellock 2002/12/18 soft path */
#ifdef _Windows
#include <windows.h> /* W Robert Kellock replaced winsock.h with windows.h */
#include <dir.h>
#include <io.h>
/* #define MAXPATHLEN 1024  W Robert Kellock 2002/08/09 shifted to isdio.h */
#else
#include <sys/param.h>
#include <sys/wait.h>
#define SOCKET int
#endif

#include <errno.h>
#include <signal.h>
/* W Robert Kellock 2002/08/09 hard paths */
/*
W Robert Kellock 2003/02/17 removed as not used

#include "../lib/queues.h"
#include "../lib/libisect.h"
*/
#include "../isd/isdio.h"

#ifndef SCOPE
#define SCOPE extern
#endif

/*
W Robert Kellock 2003/02/17 removed as not used

struct ReplyTo {
       Node node;
       char portname[32];
       int pid;
        
#ifdef SYSV
		union wait statusp;
#else
		int statusp;
#endif
};
*/

/* SCOPE Queue ReplyToQueue; W Robert Kellock 2003/02/17 removed as not used */
SCOPE int SigChildOccurred;
SCOPE char rmt_pathname[MAXPATHLEN];

#define MAXARGS 20 /* W Robert Kellock 2003/04/15 */

extern char *rmtrenice(char *);
extern int rmtdo(SOCKET sock, char *command);

#endif
