#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "isdio.h"

Xport void isdSockOpts(SOCKET sock)
{
	int err;
	int optval;
	int optlen;

	optval = 1;

/* don't buffer TCP send()s - should speed send()s */
	err = setsockopt(sock, IPPROTO_TCP, TCP_NODELAY, (char *) &optval, optlen = sizeof optval);

/* don't worry about re-using ports as long as they aren't in-use */
	err = setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (char *) &optval, optlen);

/* these getsockopt()s are for debugging information only */
	err = getsockopt(sock, IPPROTO_TCP, TCP_NODELAY, (char *) &optval, &optlen);
	err = getsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (char *) &optval, &optlen);
	err = getsockopt(sock, SOL_SOCKET, SO_RCVBUF, (char *) &optval, &optlen);
	err = getsockopt(sock, SOL_SOCKET, SO_SNDBUF, (char *) &optval, &optlen);
}
