#include "isdio.h"
#include <errno.h>

char * Xport isdxstrerror(int error)
{
	static char retstring[256];

	switch (error) {
	case -1:
		sprintf(retstring, "service may not be in /etc/services\n");
		break;
	case -2:
		sprintf(retstring, "opening socket to talk to rmtexecd\n%s\n", strerror(errno));
		break;
	case -3:
		sprintf(retstring, "remote host may not be in /etc/hosts\n");
		break;
	case -4:
		sprintf(retstring, "connect()ing\n%s\n", strerror(errno));
		break;
	case -5:
		sprintf(retstring, "send()ing\n%s\n", strerror(errno));
		break;
	case -6:
		sprintf(retstring, "recv()ing\n%s\n", strerror(errno));
		break;
	default:
		sprintf(retstring, "unknown error condition\n");
		break;
	}
	return retstring;
}
