/*
   this is one of those dangerous modules becuase it
   screws with one of the queues.  It returns the queue
   that any search should continue from.
 */
#include "isectd.h"
#include <time.h>

isdClient *
isdClientEOF(isdClient * client)
{
	Node *node;
	int didnt_find_any = 1;
	isdWorker *worker;
	isdClient *continueFrom = client;

	if (client->socket != INVALID_SOCKET) {
		FD_CLR(client->socket, &isdData.allfds);
		isdLogout(client->socket);
		client->socket = INVALID_SOCKET;
	}
/*
   Make sure a worker isn't busy working on a sequence for
   the recently deceased client.  If there's an outstanding
   transaction, the client will be free()'d when the last worker
   reply comes back.
*/
/*
W. Robert Kellock 2021-01-17  	What happens if a busy worker is in an endless loop? The client would want to 
				detach from it, but the code below doesn't allow the deceased client to be removed 
				from the worker. See workerreply.c
*/
	for (node = QNULL; (node = QueueSearch(&isdData.BusyWorkers, QEQ, offsetof(isdWorker, client_id), client->id, node)) != QNULL;) {
		worker = (isdWorker *) node;
		if (worker != (isdWorker *) QNULL) {
			isdLog("client %d had outstanding request at worker %d\n", client->id, worker->id);
			didnt_find_any = 0;
			if (worker->header.more) {
				isdHeader localHeader;
				localHeader = client->header;
				localHeader.more = 0;
				isdSend(worker->socket, "", 0, &localHeader);
			}
		}
	}

	if (didnt_find_any) {
		isdLog("client %d\n", client->id);
		isdLog("            login seconds : %d\n", time(0) - client->login_time);
		isdLog("             transactions : %d\n", client->Transactions);
		isdLog("    average response time : %d.%03d seconds\n", client->AverageTime.tv_sec, client->AverageTime.tv_usec / 1000);
		if (client->msgBuffer)
		  free(client->msgBuffer);
		continueFrom = (isdClient *) client->node.previous;
		free((char *) RemoveNode((Node *) client));

		/* if I've just removed one, I should have room for another */
		isdStartListening();
	}
	return continueFrom;
}
