#ifndef ISECTDPROTO_H
#define ISECTDPROTO_H

/* W Robert Kellock 2002/08/17 removed extern operator */
void		isdClientSend(isdClient *, char *message, isdHeader *);
int			isd1024(void);
char *		isdAddService(char *, int, char **);
char *		isdAddWorker(char *, int, char **);
isdWorker *	isdBusyWorker(isdWorker * worker, isdClient * client);
void 		isdCheckReady(fd_set);
isdClient *	isdClientEOF(isdClient *client);
void 		isdClientLogin(fd_set);
char *		isdCommands(char *);
char *		isdConfig(char *, int, char **);
void 		isdBucketParams(int, int);
/* extern SOCKET		isdSocket(char *, char *, SOCKET *, int *); W Robert Kellock 2002/08/09 */
void 		isdLogEvent(char *fmt, ...);
void 		isdIdleWorker(isdWorker *);
int		    isdInit(int, char **);
void	    isdHandler(int);
void 		isdInternalAffairs(fd_set);
void 		isdLazyWorker(isdWorker *);
void 		isdLogEvent(char *fmt, ...);
int			isdMaxUsers(void);
int			isdMemDebug(char *command);
void 		isdPriList(isdClient *client);
int			isdSetEvents(char *, int, char **);
int			isdSockEOF(SOCKET);
void		isdStartListening(void);
int			isdStartWorkers(void);
int			isdStartWorker(isdWorker *);
char *		isdStatClientQueue(char *cp, int, char**);
char *		isdStatistics(char *cp);
char *		isdStatWorkerQueue(char *cp, Queue * queue);
void		isdStopListening(void);
void 		isdTaskMaster(void);
void 		isdTranStats(isdWorker *worker);
int			isdToWorker(isdWorker * worker);
isdWorker*	isdVldWrkrId(int id);
void 		isdWorkerDeaths(fd_set, Queue *);
void 		isdWorkerReply(fd_set);
void 		isdWorkerLogin(fd_set);
void 		isdWorkerReady(fd_set, Queue *);
int			isdWorkerStartable(isdWorker *);
int			isdWorkLoop(void);
void 		isdZeroClientQueue(void);
void 		isdZeroWorkerQueue(Queue *);

/*
This is the what we use for time values
*/

double 		TimebAverage(double avgtime, double thistime, int alltimes);
/* void		GetTime(ISDTIMETYPE *); W Robert Kellock 2002/08/17 moved to lib */

/* extern void isdLog(char *fmt, ...);  W Robert Kellock 2002/08/14 */

#endif
