#include "isectd.h"

void 
isdWorkerLogin(fd_set readfds)
{
	fd_set myfds;
	int err = 1, address_len;
	SOCKET sock = INVALID_SOCKET;
	isdWorker *worker;
	struct sockaddr_in sockaddr;
	struct timeval timeout;
	struct hostent *he;

	if (FD_ISSET(isdData.socket, &readfds)) {
		address_len = sizeof(sockaddr);
		isdLogEvent("worker ready to login");
		sock = accept(isdData.socket, (struct sockaddr *) &sockaddr, &address_len);
		if (sock != INVALID_SOCKET) {
			isdSockOpts(sock);
			worker = (isdWorker *) calloc(1, sizeof *worker);
			worker->socket = sock;
			memcpy((char *) &worker->sockaddr, (char *) &sockaddr, address_len);
			he = gethostbyaddr((char *) &worker->sockaddr.sin_addr, sizeof(struct in_addr), worker->sockaddr.sin_family);
			strcpy(worker->loghost, he ? he->h_name : "unknown");
			InsertHead(&isdData.NewWorkers, (Node *) worker);
			if (!FD_ISSET(worker->socket, &isdData.allfds))
				FD_SET(worker->socket, &isdData.allfds);
			err = 0;
		}
	}
}
