#ifndef LIBISECT_H
#define LIBISECT_H

#include <mingw.h> /* W Robert Kellock 2002/12/18 soft path */
#ifdef _Windows
#include <windows.h>  /* W Robert Kellock 2002/08/09 windows.h instead of winsock.h */
#ifdef __WIN32__
#define far
#endif
/* 
   W Robert Kellock 2002/08/15 
   Build DLL, use DLL or static library
*/
#if BUILDING_DLL
#define Xport __declspec (dllexport)
#elif STATIC_LIB
#define Xport _export far pascal
#else
#define Xport __declspec (dllimport)
#endif

#else
#define Xport
#endif

/* W Robert Kellock 2002/08/09 function prototype required */
Xport char* zapLine(char *, int, int);

/*
Time is so difficult...
*/
#ifndef _Windows      /* W Robert Kellock 2002/12/18 Added Windows switch */
#include <sys/time.h>
#include <unistd.h>
#else
#include <time.h>
#endif

#define ISDTIMETYPE struct timeval
Xport void GetTime(ISDTIMETYPE *);

#ifndef _Windows
/* W Robert Kellock 2002/08/09 Added Windows switch */
Xport char* strupr(char *);
#endif

/* W Robert Kellock 2002/08/09 Added int parameter
#ifdef _Windows
extern void * Xport gettimeofday(struct timeval *tv, int);
#endif
*/

#endif
